#ifndef TEST_MANAGEMENT_TASKS_H_
#define TEST_MANAGEMENT_TASKS_H_

/* Nichestack definitions */
#include "C:\Users\jal\Desktop\software\test_bsp\iniche\src\h\nios2\ipport.h"
#include "C:\Users\jal\Desktop\software\test_bsp\iniche\src\h\libport.h"
#include "C:\Users\jal\Desktop\software\test_bsp\iniche\src\nios2\osport.h"
#include "C:\Users\jal\Desktop\software\test_bsp\iniche\src\h\bsdsock.h"

#include "alt_types.h"

#define STREAM_SERVER_TASK_PRIORITY		(19)	// this server task must be lower priority than the handler tasks
#define SERVER_HANDLER_TASK_0_PRIORITY	(18)
#define SERVER_HANDLER_TASK_1_PRIORITY	(17)
#define SERVER_HANDLER_TASK_2_PRIORITY	(16)
#define SERVER_HANDLER_TASK_3_PRIORITY	(15)
#define STREAM_CLIENT_TASK_PRIORITY		(24)	// this client task must be lower priority than the handler tasks
#define CLIENT_HANDLER_TASK_0_PRIORITY  (23)
#define CLIENT_HANDLER_TASK_1_PRIORITY	(22)
#define CLIENT_HANDLER_TASK_2_PRIORITY	(21)
#define CLIENT_HANDLER_TASK_3_PRIORITY	(20)

#define STREAM_SERVER_PUBLIC_PORT	(8181)

//
// STRING DEFINITIONS
//
#define BEGIN_STR "<BEGIN>"
#define BEGIN_STR_SIZE (sizeof BEGIN_STR) - 1
#define BUSY_STR "<BUSY>"
#define BUSY_STR_SIZE (sizeof BUSY_STR) - 1
#define END_STR "<END>"
#define END_STR_SIZE (sizeof END_STR) - 1
#define REQUEST_STR "<REQUEST "
#define REQUEST_STR_SIZE (sizeof REQUEST_STR) - 1
#define ACCEPT_STR "<ACCEPT>"
#define ACCEPT_STR_SIZE (sizeof ACCEPT_STR) - 1
#define DENY_STR "<DENY>"
#define DENY_STR_SIZE (sizeof DENY_STR) - 1
#define START_STR "<START "
#define START_STR_SIZE (sizeof START_STR) - 1
#define START_ACK_STR "<START>"
#define START_ACK_STR_SIZE (sizeof START_ACK_STR) - 1
#define STOP_STR "<STOP>"
#define STOP_STR_SIZE (sizeof STOP_STR) - 1
#define RELEASE_STR "<RELEASE>"
#define RELEASE_STR_SIZE (sizeof RELEASE_STR) - 1
#define HUH_STR "<HUH>"
#define HUH_STR_SIZE (sizeof HUH_STR) - 1

//
// SERVER STATE DEFINITIONS
//
#define BEGIN_STATE			(0)
#define ESTABLISHED_STATE	(1)
#define START_STATE			(2)

extern OS_EVENT *stream_client_Mbox;
extern OS_EVENT *client_request_Mbox;

extern struct inet_taskinfo the_stream_server_task;
extern struct inet_taskinfo the_stream_client_task;

extern void stream_server_task(void *task_data);
extern void stream_client_task(void *task_data);
extern int tx_command(int fd, char *buffer, int length, int flags);

extern volatile int client_session_fd[];

typedef volatile struct {
	volatile alt_u32 ip_address;		// HBO
	volatile alt_u32 packet_length;
	volatile struct GenericIO pio;
} client_request;

#endif /*TEST_MANAGEMENT_TASKS_H_*/
