#ifndef MY_OS_HOOKS_H_
#define MY_OS_HOOKS_H_

#include "system.h"
#include "alt_types.h"

//
//	User must have an altera_avalon_timer peripheral in their system to
//	dedicate to this function.  You should set the two macros below to the
//	proper macro names for your stat timer peripheral from system.h.
//
#define THE_STAT_TIMER_FREQ		STAT_TIMER_FREQ
#define THE_STAT_TIMER_BASE		STAT_TIMER_BASE

//
// In the current uCOS-II implmentation it appears to collect stats every
// 1/10 of a second, if your implementation is different, then you should
// change STATS_PER_SECOND to align with your implementation.
// You may arbitrarily choose how many seconds worth of stats you wish to
// collect with the STATS_SECONDS macro.
//
#define STATS_PER_SECOND		(10)
#define STATS_SECONDS			(10)
#define CPU_STATS_COUNT			(STATS_SECONDS * STATS_PER_SECOND)

extern alt_u32 my_cpu_stats[];
extern alt_u32 my_current_cpu_stat;

extern alt_u32 timetickhook_running;
extern alt_u32 longest_tick;
extern alt_u32 lastTickHookTimer;

extern alt_u32 exitCount[];
extern alt_u32 runTime[];
extern alt_u32 maxTime[];
extern alt_u32 last_exitCount[];
extern alt_u32 last_runTime[];
extern alt_u32 last_maxTime[];
extern alt_u32 lastStatTimer;
extern alt_u32 OSTaskSwHook_running ;

extern void OSTaskStatHook(void);
extern void OSTimeTickHook(void);
extern void OSTaskSwHook (void);
extern int cpu_stats(void * pio);
extern int clear_cpu_stats(void * pio);
extern alt_u32 getStatTick(void);
extern void initStatTick(void);

#endif /*MY_OS_HOOKS_H_*/
